Index: /branches/libIGCM/GYRE_LOBSTER/IGCM00/COMP/gyre.card
===================================================================
--- /branches/libIGCM/GYRE_LOBSTER/IGCM00/COMP/gyre.card	(revision 1372)
+++ /branches/libIGCM/GYRE_LOBSTER/IGCM00/COMP/gyre.card	(revision 1373)
@@ -4,5 +4,5 @@
 [UserChoices]
 #-- Number of time step per day for GYRE configuration (default = 12)
-GYRE_NPDT_JOURS=12
+GYRE_NDT_DAY=12
 
 [InitialStateFiles]
Index: /branches/libIGCM/GYRE_LOBSTER/IGCM00/COMP/gyre.driver
===================================================================
--- /branches/libIGCM/GYRE_LOBSTER/IGCM00/COMP/gyre.driver	(revision 1372)
+++ /branches/libIGCM/GYRE_LOBSTER/IGCM00/COMP/gyre.driver	(revision 1373)
@@ -7,8 +7,8 @@
     JOB_NAME=${config_UserChoices_JobName}
 
-    ORCA_NPDT_JOUR=${gyre_UserChoices_GYRE_NPDT_JOURS:=12}
-
-    # Attention : ORCA_RDT must be an integer
-    (( ORCA_RDT = 60 * 60 * 24 / ${ORCA_NPDT_JOUR} ))
+    OPA_NDT_DAY=${gyre_UserChoices_GYRE_NDT_DAY:=12}
+
+    # Attention : OPA_RDT must be an integer
+    (( OPA_RDT = 60 * 60 * 24 / ${OPA_NDT_DAY} ))
 
     ##--Variables used by OPA --
@@ -88,5 +88,5 @@
     case ${frequency} in
 	1Y|1y)
-	    (( ORCA_NWRITE = ORCA_NPDT_JOUR * factor * $( IGCM_date_DaysInYear  ${year} ) ))          ;
+	    (( OPA_NWRITE = OPA_NDT_DAY * factor * $( IGCM_date_DaysInYear  ${year} ) ))          ;
 	    PREFIX_NWRITE=${config_UserChoices_JobName}_${factor}y ;
 	    R_OUT_OCE_NWRITE=${R_OUT_OCE_O_Y} ;
@@ -95,5 +95,5 @@
 	    WF1=${factor}Y ;;
 	1M|1m)
-	    (( ORCA_NWRITE = ORCA_NPDT_JOUR * factor * $( IGCM_date_DaysInMonth ${year} ${month} ) )) ;
+	    (( OPA_NWRITE = OPA_NDT_DAY * factor * $( IGCM_date_DaysInMonth ${year} ${month} ) )) ;
 	    PREFIX_NWRITE=${config_UserChoices_JobName}_${factor}m ;
 	    R_OUT_OCE_NWRITE=${R_OUT_OCE_O_M} ;
@@ -102,5 +102,5 @@
 	    WF1=${factor}M ;;
 	*D|*d)
-	    (( ORCA_NWRITE = ORCA_NPDT_JOUR * factor  ))  ;
+	    (( OPA_NWRITE = OPA_NDT_DAY * factor  ))  ;
 	    PREFIX_NWRITE=${config_UserChoices_JobName}_${factor}d ;
 	    R_OUT_OCE_NWRITE=${R_OUT_OCE_O_D} ;
@@ -109,5 +109,5 @@
 	    WF1=${factor}D ;;
 	*)
-	    (( ORCA_NWRITE = 0 ))                                                            ;;
+	    (( OPA_NWRITE = 0 ))                                                            ;;
     esac
 
@@ -116,19 +116,19 @@
     (( PeriodDaysSinceJC =  $( IGCM_date_DaysSinceJC ${PeriodDateBegin} ) + 1  ))
 
-    ##-- Calcul du numero de pas de temps de debut de job ORCA
-    (( ORCA_NIT000 = ( PeriodDaysSinceJC - DaysSinceJC ) * ORCA_NPDT_JOUR + 1 ))
-    (( ORCA_NPDT   = PeriodLengthInDays * ORCA_NPDT_JOUR ))
-    (( ORCA_NITEND = ORCA_NIT000 + ORCA_NPDT - 1))
-
-    ## On force 1 restart par simulation à la fin
-    ORCA_NSTOCK="${ORCA_NITEND}"
-
-    ##-- verification du nb de pas de temps par jour
-    (( NB_SEC_JOUR_MODEL = ORCA_NPDT_JOUR * ORCA_RDT ))
-    (( NB_SEC_JOUR = 60 * 60 * 24 ))
-
-    if [ ${NB_SEC_JOUR_MODEL} -ne ${NB_SEC_JOUR} ]
+    ##-- Calcul du numero de pas de temps de debut de job OPA
+    (( OPA_NIT000 = ( PeriodDaysSinceJC - DaysSinceJC ) * OPA_NDT_DAY + 1 ))
+    (( OPA_NPDT   = PeriodLengthInDays * OPA_NDT_DAY ))
+    (( OPA_NITEND = OPA_NIT000 + OPA_NPDT - 1))
+
+    ## Forcing to write one restart file at the end of period
+    OPA_NSTOCK="${OPA_NITEND}"
+
+    ##-- verification of number of timestep in a day
+    (( NB_SEC_DAY_MODEL = OPA_NDT_DAY * OPA_RDT ))
+    (( NB_SEC_DAY = 60 * 60 * 24 ))
+
+    if [ ${NB_SEC_DAY_MODEL} -ne ${NB_SEC_DAY} ]
 	then
-        echo " VERIFIER ORCA_NPDT_JOUR dans gyre.card "
+        echo " VERIFY OPA_NDT_DAY in gyre.card "
         exit
     fi
@@ -143,10 +143,10 @@
         then
 
-        #echo "PAS DE RESTART OPA"
-	ORCA_LRSTAR=.FALSE.
-	ORCA_NRSTDT=0
-        #echo pas de meshmask en parallele
-	ORCA_NMSH=1
-	( [ X${BATCH_NUM_PROC_TOT} != X ] && [ "${BATCH_NUM_PROC_TOT}" -gt 1 ] ) && ORCA_NMSH=0
+        #echo "NO RESTART OPA"
+	OPA_LRSTAR=.FALSE.
+	OPA_NRSTDT=0
+        #echo no meshmask en parallele
+	OPA_NMSH=1
+	( [ X${BATCH_NUM_PROC_TOT} != X ] && [ "${BATCH_NUM_PROC_TOT}" -gt 1 ] ) && OPA_NMSH=0
 
         else 
@@ -154,8 +154,8 @@
         #    "${config_OCE_Restart}" = "y" 
 
-        #echo "RESTART OPA" et pas de verif pour cumulperiod=1
-	ORCA_LRSTAR=.TRUE.
-	ORCA_NRSTDT=0
-	ORCA_NMSH=0
+        #echo "RESTART OPA" and no verif cumulperiod=1
+	OPA_LRSTAR=.TRUE.
+	OPA_NRSTDT=0
+	OPA_NMSH=0
         fi
 
@@ -164,5 +164,5 @@
         then
 
-        #echo "PAS DE RESTART TOP"
+        #echo "NO RESTART TOP"
         TOP_LRSTTR=.FALSE.
         TOP_NRSTTR=0
@@ -182,5 +182,5 @@
         then
 
-        #echo "PAS DE RESTART TRENDS"
+        #echo "NO RESTART TRENDS"
         TRENDS_LRSTTR=.FALSE.
 
@@ -197,7 +197,7 @@
 
         #echo "RESTART OPA"
-	ORCA_LRSTAR=.TRUE.
-	ORCA_NRSTDT=2
-	ORCA_NMSH=0
+	OPA_LRSTAR=.TRUE.
+	OPA_NRSTDT=2
+	OPA_NMSH=0
 
         #echo "RESTART TOP"
@@ -213,28 +213,28 @@
        case ${config_UserChoices_CalendarType} in
                 leap)
-                ORCA_NLEAPY=1;;
+                OPA_NLEAPY=1;;
                 noleap)
-                ORCA_NLEAPY=0;;
+                OPA_NLEAPY=0;;
                 360d)
-                ORCA_NLEAPY=30;;
+                OPA_NLEAPY=30;;
                 *)
-                ORCA_NLEAPY=30
+                OPA_NLEAPY=30
         esac
 
         typeset -r PRECIS=8
-	NEMO_END=$( echo $( awk "BEGIN { printf \"%0${PRECIS}d\",${ORCA_NITEND} }" ) ) 
+	NEMO_END=$( echo $( awk "BEGIN { printf \"%0${PRECIS}d\",${OPA_NITEND} }" ) ) 
 
     sed -e "s%${PAT_CEXPER}%       cexper=\"${config_UserChoices_JobName}\"%" \
-	-e "s%${PAT_NIT000}%       nit000=${ORCA_NIT000}%"                    \
-	-e "s%${PAT_NITEND}%       nitend=${ORCA_NITEND}%"                    \
-	-e "s%${PAT_NWRITE}%       nwrite=${ORCA_NWRITE}%"                    \
-	-e "s%${PAT_NTRD}%         ntrd=${ORCA_NWRITE}%"                      \
-	-e "s%${PAT_RESTAR}%       ln_rstart=${ORCA_LRSTAR}%"                 \
-	-e "s%${PAT_RDT}%          rdt=${ORCA_RDT}%"                          \
-	-e "s%${PAT_NSTOCK}%       nstock=${ORCA_NSTOCK}%"                    \
-	-e "s%${PAT_NRSTAR}%       nrstdt=${ORCA_NRSTDT}%"                    \
+	-e "s%${PAT_NIT000}%       nit000=${OPA_NIT000}%"                    \
+	-e "s%${PAT_NITEND}%       nitend=${OPA_NITEND}%"                    \
+	-e "s%${PAT_NWRITE}%       nwrite=${OPA_NWRITE}%"                    \
+	-e "s%${PAT_NTRD}%         ntrd=${OPA_NWRITE}%"                      \
+	-e "s%${PAT_RESTAR}%       ln_rstart=${OPA_LRSTAR}%"                 \
+	-e "s%${PAT_RDT}%          rdt=${OPA_RDT}%"                          \
+	-e "s%${PAT_NSTOCK}%       nstock=${OPA_NSTOCK}%"                    \
+	-e "s%${PAT_NRSTAR}%       nrstdt=${OPA_NRSTDT}%"                    \
 	-e "s%${PAT_NDATE0}%       ndate0=${PeriodDateBegin}%"                \
-	-e "s%${PAT_NLEAPY}%       nleapy=${ORCA_NLEAPY}%"                    \
-	-e "s%${PAT_NMSH}%         nmsh=${ORCA_NMSH}%"                        \
+	-e "s%${PAT_NLEAPY}%       nleapy=${OPA_NLEAPY}%"                    \
+	-e "s%${PAT_NMSH}%         nmsh=${OPA_NMSH}%"                        \
         -e "s%${PAT_RSTRTTRD}%     ln_trdmld_restart=${TRENDS_LRSTTR}%"       \
 	namelist > namelist.tmp
@@ -242,8 +242,8 @@
     IGCM_sys_Mv namelist.tmp namelist
 
-# on force les sorties TOP comme les sorties OPA
-
-    sed -e "s%${PAT_TOP_NWRITETRC}%       nwritetrc=${ORCA_NWRITE}%"               \
-        -e "s%${PAT_TOP_NWRITETRD}%       ntrd_trc=${ORCA_NWRITE}%"                \
+# we force TOP outputs like OPA outputs
+
+    sed -e "s%${PAT_TOP_NWRITETRC}%       nwritetrc=${OPA_NWRITE}%"               \
+        -e "s%${PAT_TOP_NWRITETRD}%       ntrd_trc=${OPA_NWRITE}%"                \
         -e "s%${PAT_TOP_LRSTTR}%          lrsttr=${TOP_LRSTTR}%"                   \
         -e "s%${PAT_TOP_NRSTTR}%          nrsttr=${TOP_NRSTTR}%"                   \
@@ -253,7 +253,7 @@
     IGCM_sys_Mv namelist_top.tmp namelist_top
 
-# on force les sorties LOBSTER comme les sorties OPA
-
-    sed -e "s%${PAT_LOB_NWRITEDIA}%       nwritedia=${ORCA_NWRITE}%"              \
+# we force LOBSTER outputs like OPA outputs
+
+    sed -e "s%${PAT_LOB_NWRITEDIA}%       nwritedia=${OPA_NWRITE}%"              \
         namelist_lobster > namelist_lobster.tmp
 