Index: trunk/NEMO/OPA_SRC/TRA/traqsr.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/traqsr.F90	(revision 1415)
+++ trunk/NEMO/OPA_SRC/TRA/traqsr.F90	(revision 1423)
@@ -4,9 +4,10 @@
    !! Ocean physics: solar radiation penetration in the top ocean levels
    !!======================================================================
-   !! History :  6.0  !  90-10  (B. Blanke)  Original code
-   !!            7.0  !  91-11  (G. Madec)
-   !!                 !  96-01  (G. Madec)  s-coordinates
-   !!            8.5  !  02-06  (G. Madec)  F90: Free form and module
-   !!            9.0  !  05-11  (G. Madec) zco, zps, sco coordinate
+   !! History :  OPA  !  1990-10  (B. Blanke)  Original code
+   !!            7.0  !  1991-11  (G. Madec)
+   !!                 !  1996-01  (G. Madec)  s-coordinates
+   !!   NEMO     1.0  !  2002-06  (G. Madec)  F90: Free form and module
+   !!             -   !  2005-11  (G. Madec) zco, zps, sco coordinate
+   !!            3.2  !  2009-04  (G. Madec & NEMO team) 
    !!----------------------------------------------------------------------
 
@@ -24,20 +25,23 @@
    USE phycst          ! physical constants
    USE prtctl          ! Print control
+   USE iom             ! I/O manager
+   USE fldread         ! read input fields
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   tra_qsr      ! routine called by step.F90 (ln_traqsr=T)
-   PUBLIC   tra_qsr_init ! routine called by opa.F90
-
-   !!* Namelist namqsr: penetrative solar radiation
-   LOGICAL , PUBLIC ::   ln_traqsr = .TRUE.   !: qsr flag (Default=T)
-   REAL(wp), PUBLIC ::   rabs = 0.58_wp       ! fraction associated with xsi1
-   REAL(wp), PUBLIC ::   xsi1 = 0.35_wp       ! first depth of extinction 
-   REAL(wp), PUBLIC ::   xsi2 = 23.0_wp       ! second depth of extinction (default values: water type Ib)
-   LOGICAL , PUBLIC ::   ln_qsr_sms = .false. ! flag to use or not the biological fluxes for light 
+   PUBLIC   tra_qsr        ! routine called by step.F90 (ln_traqsr=T)
+
+   !                                           !!* Namelist namqsr: penetrative solar radiation
+   LOGICAL , PUBLIC ::   ln_traqsr  = .TRUE.    !: light absorption (qsr) flag
+   LOGICAL , PUBLIC ::   ln_qsr_rgb = .FALSE.   !: Red-Green-Blue light absorption flag  
+   LOGICAL , PUBLIC ::   ln_qsr_bio = .FALSE.   !: bio-model      light absorption flag
+   INTEGER , PUBLIC ::   nn_chldta  = 0         !: use Chlorophyll data (=1) or not (=0)
+   REAL(wp), PUBLIC ::   rn_abs     = 0.58_wp   !: fraction absorbed in the very near surface (RGB & 2 bands)
+   REAL(wp), PUBLIC ::   rn_si0     = 0.35_wp   !: very near surface depth of extinction      (RGB & 2 bands)
+   REAL(wp), PUBLIC ::   rn_si1     = 23.0_wp   !: deepest depth of extinction (water type I)       (2 bands)
+   REAL(wp), PUBLIC ::   rn_si2     = 61.8_wp   !: deepest depth of extinction (blue & 0.01 mg.m-3)     (RGB)
    
-   INTEGER ::   nksr   ! number of levels
-   REAL(wp), DIMENSION(jpk) ::   gdsr   ! profile of the solar flux penetration
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_chl   ! structure of input Chl (file informations, fields read)
 
    !! * Substitutions
@@ -45,5 +49,5 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
    !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
@@ -59,11 +63,10 @@
       !!      penetration and add it to the general temperature trend.
       !!
-      !! ** Method  : The profile of the solar radiation within the ocean is
-      !!      defined through two penetration length scale (xsr1,xsr2) and a 
-      !!      ratio (rabs) as :
-      !!         I(k) = Qsr*( rabs*EXP(z(k)/xsr1) + (1.-rabs)*EXP(z(k)/xsr2) )
-      !!         The temperature trend associated with the solar radiation
-      !!      penetration is given by :
-      !!            zta = 1/e3t dk[ I ] / (rau0*Cp)
+      !! ** Method  : The profile of the solar radiation within the ocean is defined
+      !!      through 2 wavebands (rn_si0,rn_si1) or 3 wavebands (RGB) and a ratio rn_abs
+      !!      Considering the 2 wavebands case:
+      !!         I(k) = Qsr*( rn_abs*EXP(z(k)/rn_si0) + (1.-rn_abs)*EXP(z(k)/rn_si1) )
+      !!         The temperature trend associated with the solar radiation penetration 
+      !!         is given by : zta = 1/e3t dk[ I ] / (rau0*Cp)
       !!         At the bottom, boudary condition for the radiation is no flux :
       !!      all heat which has not been absorbed in the above levels is put
@@ -76,4 +79,7 @@
       !! ** Action  : - update ta with the penetrative solar radiation trend
       !!              - save the trend in ttrd ('key_trdtra')
+      !!
+      !! Reference  : Jerlov, N. G., 1968 Optical Oceanography, Elsevier, 194pp.
+      !!              Lengaigne et al. 2007, Clim. Dyn., V28, 5, 503-516.
       !!----------------------------------------------------------------------
       USE oce, ONLY :   ztrdt => ua   ! use ua as 3D workspace   
@@ -82,6 +88,10 @@
       INTEGER, INTENT(in) ::   kt     ! ocean time-step
       !!
-      INTEGER  ::    ji, jj, jk       ! dummy loop indexes
-      REAL(wp) ::   zc0 , zta         ! temporary scalars
+      INTEGER  ::   ji, jj, jk           ! dummy loop indices
+      INTEGER  ::   irgb                 ! temporary integers
+      REAL(wp) ::   zchl, zcoef, zsi0r   ! temporary scalars
+      REAL(wp) ::   zc0, zc1, zc2, zc3   !    -         -
+      REAL(wp), DIMENSION(jpi,jpj)     ::   zekb, zekg, zekr            ! 2D workspace
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ze0, ze1 , ze2, ze3, zea    ! 3D workspace
       !!----------------------------------------------------------------------
 
@@ -91,4 +101,5 @@
          IF(lwp) WRITE(numout,*) '~~~~~~~'
          CALL tra_qsr_init
+         IF( .NOT.ln_traqsr )   RETURN
       ENDIF
 
@@ -98,64 +109,95 @@
       ENDIF
 
-      ! ---------------------------------------------- !
-      !  Biological fluxes  : all vertical coordinate  !
-      ! ---------------------------------------------- !
-      IF( lk_qsr_sms .AND. ln_qsr_sms ) THEN      
-         !                                                   ! ===============
-         DO jk = 1, jpkm1                                    ! Horizontal slab
-            !                                                ! ===============
+      
+      !                                           ! ============================================== !
+      IF( lk_qsr_bio ) THEN                       !  bio-model fluxes  : all vertical coordinates  !
+         !                                        ! ============================================== !
+         DO jk = 1, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
-                  zc0 = ro0cpr  / fse3t(ji,jj,jk)         ! compute the qsr trend
-                  zta = zc0 * ( etot3(ji,jj,jk  ) * tmask(ji,jj,jk)     &
-                     &        - etot3(ji,jj,jk+1) * tmask(ji,jj,jk+1) )
-                  ta(ji,jj,jk) = ta(ji,jj,jk) + zta       ! add qsr trend to the temperature trend
+                  ta(ji,jj,jk) = ta(ji,jj,jk) + ro0cpr * ( etot3(ji,jj,jk) - etot3(ji,jj,jk+1) ) / fse3t(ji,jj,jk) 
                END DO
             END DO
-            !                                                ! ===============
-         END DO                                              !   End of slab
-         !                                                   ! ===============
-
-      ! ---------------------------------------------- !
-      !  Ocean alone :
-      ! ---------------------------------------------- !
-      ELSE
-         !                                                ! =================== !
-         IF( ln_sco ) THEN                                !    s-coordinate     !
-            !                                             ! =================== !
-            DO jk = 1, jpkm1
-               ta(:,:,jk) = ta(:,:,jk) + etot3(:,:,jk) * qsr(:,:)
-            END DO
-         ENDIF
-         !                                                ! =================== !
-         IF( ln_zps ) THEN                                !    partial steps    !
-            !                                             ! =================== !
+         END DO
+         !                                        ! ============================================== !
+      ELSE                                        !  Ocean alone : 
+         !                                        ! ============================================== !
+         !
+         !                                                ! ------------------------- !
+         IF( ln_qsr_rgb) THEN                             !  R-G-B  light penetration !
+            !                                             ! ------------------------- !
+            ! Set chlorophyl concentration
+            IF( nn_chldta ==1 ) THEN                             !*  Variable Chlorophyll
+               !
+               CALL fld_read( kt, 1, sf_chl )                         ! Read Chl data and provides it at the current time step
+               !         
+!CDIR COLLAPSE
+!CDIR NOVERRCHK
+               DO jj = 1, jpj                                         ! Separation in R-G-B depending of the surface Chl
+!CDIR NOVERRCHK
+                  DO ji = 1, jpi
+                     zchl = MIN( 10. , MAX( 0.03, sf_chl(1)%fnow(ji,jj) ) )
+                     achl(ji,jj) = zchl
+                     irgb = NINT( 41 + 20.*LOG10(zchl) + 1.e-15 )
+                     zekb(ji,jj) = rkrgb(1,irgb)
+                     zekg(ji,jj) = rkrgb(2,irgb)
+                     zekr(ji,jj) = rkrgb(3,irgb)
+                  END DO
+               END DO
+               !
+               zsi0r = 1.e0 / rn_si0
+               zcoef  = ( 1. - rn_abs ) / 3.e0                        ! equi-partition in R-G-B
+               ze0(:,:,1) = rn_abs  * qsr(:,:)
+               ze1(:,:,1) = zcoef * qsr(:,:)
+               ze2(:,:,1) = zcoef * qsr(:,:)
+               ze3(:,:,1) = zcoef * qsr(:,:)
+               zea(:,:,1) =         qsr(:,:)
+               !
+               DO jk = 2, nksr+1
+!CDIR NOVERRCHK
+                  DO jj = 1, jpj
+!CDIR NOVERRCHK   
+                     DO ji = 1, jpi
+                        zc0 = ze0(ji,jj,jk-1) * EXP( - fse3t(ji,jj,jk-1) * zsi0r     )
+                        zc1 = ze1(ji,jj,jk-1) * EXP( - fse3t(ji,jj,jk-1) * zekb(ji,jj) )
+                        zc2 = ze2(ji,jj,jk-1) * EXP( - fse3t(ji,jj,jk-1) * zekg(ji,jj) )
+                        zc3 = ze3(ji,jj,jk-1) * EXP( - fse3t(ji,jj,jk-1) * zekr(ji,jj) )
+                        ze0(ji,jj,jk) = zc0
+                        ze1(ji,jj,jk) = zc1
+                        ze2(ji,jj,jk) = zc2
+                        ze3(ji,jj,jk) = zc3
+                        zea(ji,jj,jk) = ( zc0 + zc1 + zc2 + zc3 ) * tmask(ji,jj,jk)
+                     END DO
+                  END DO
+               END DO
+               !
+               DO jk = 1, nksr                                        ! compute and add qsr trend to ta
+                  ta(:,:,jk) = ta(:,:,jk) + ro0cpr * ( zea(:,:,jk) - zea(:,:,jk+1) ) / fse3t(:,:,jk)
+               END DO
+               !
+            ELSE                                                 !*  Constant Chlorophyll
+               DO jk = 1, nksr
+                  ta(:,:,jk) = ta(:,:,jk) + etot3(:,:,jk) * qsr(:,:)
+               END DO
+            ENDIF
+
+!!gm BUG  the case key_vvl is missing: etot3 should be recomputed at each time step !!!
+
+            !                                             ! ------------------------- !
+         ELSE                                             !  2 band light penetration !
+            !                                             ! ------------------------- !
+            !
             DO jk = 1, nksr
                DO jj = 2, jpjm1
                   DO ji = fs_2, fs_jpim1   ! vector opt.
-                     ! qsr trend from gdsr
-                     zc0 = qsr(ji,jj) / fse3t(ji,jj,jk)
-                     zta = zc0 * ( gdsr(jk) * tmask(ji,jj,jk) - gdsr(jk+1) * tmask(ji,jj,jk+1) )
-                     ! add qsr trend to the temperature trend
-                     ta(ji,jj,jk) = ta(ji,jj,jk) + zta
+                     ta(ji,jj,jk) = ta(ji,jj,jk) + etot3(ji,jj,jk) * qsr(ji,jj)
                   END DO
                END DO
             END DO
+            !
          ENDIF
-         !                                                ! =================== !
-         IF( ln_zco ) THEN                                !     z-coordinate    !
-            !                                             ! =================== !
-            DO jk = 1, nksr
-               zc0 = 1. / e3t_0(jk)
-               DO jj = 2, jpjm1
-                  DO ji = fs_2, fs_jpim1   ! vector opt.
-                     ! qsr trend
-                     zta = qsr(ji,jj) * zc0 * ( gdsr(jk)*tmask(ji,jj,jk) - gdsr(jk+1)*tmask(ji,jj,jk+1) )
-                     ! add qsr trend to the temperature trend
-                     ta(ji,jj,jk) = ta(ji,jj,jk) + zta      
-                  END DO
-               END DO
-            END DO
-         ENDIF
+
+!!gm BUG  the case key_vvl is missing: etot3 should be recomputed at each time step !!!
+
          !
       ENDIF
@@ -178,39 +220,158 @@
       !!
       !! ** Method  :   The profile of solar radiation within the ocean is set
-      !!      from two length scale of penetration (xsr1,xsr2) and a ratio
-      !!      (rabs). These parameters are read in the namqsr namelist. The
+      !!      from two length scale of penetration (rn_si0,rn_si1) and a ratio
+      !!      (rn_abs). These parameters are read in the namqsr namelist. The
       !!      default values correspond to clear water (type I in Jerlov' 
       !!      (1968) classification.
       !!         called by tra_qsr at the first timestep (nit000)
       !!
-      !! ** Action  : - initialize xsr1, xsr2 and rabs
+      !! ** Action  : - initialize rn_si0, rn_si1 and rn_abs
       !!
       !! Reference : Jerlov, N. G., 1968 Optical Oceanography, Elsevier, 194pp.
       !!----------------------------------------------------------------------
-      INTEGER  ::   ji, jj, jk   ! dummy loop index
-      INTEGER  ::   indic        ! temporary integer
-      REAL(wp) ::   zc0 , zc1 , zc2    ! temporary scalars
-      REAL(wp) ::   zcst, zdp1, zdp2   !    "         "
-
-      NAMELIST/namqsr/ ln_traqsr, rabs, xsi1, xsi2, ln_qsr_sms
-      !!----------------------------------------------------------------------
-
-      REWIND ( numnam )           ! Read Namelist namqsr : ratio and length of penetration
-      READ   ( numnam, namqsr )
-
-      IF( ln_traqsr  ) THEN       ! Parameter control and print
-         IF(lwp) THEN
-            WRITE(numout,*)
-            WRITE(numout,*) 'tra_qsr_init : penetration of the surface solar radiation'
-            WRITE(numout,*) '~~~~~~~~~~~~'
-            WRITE(numout,*) '    Namelist namqsr : set the parameter of penetration'
-            WRITE(numout,*) '        fraction associated with xsi     rabs        = ',rabs
-            WRITE(numout,*) '        first depth of extinction        xsi1        = ',xsi1
-            WRITE(numout,*) '        second depth of extinction       xsi2        = ',xsi2
-            IF( lk_qsr_sms ) THEN
-               WRITE(numout,*) '     Biological fluxes for light(Y/N) ln_qsr_sms  = ',ln_qsr_sms
+      INTEGER  ::   ji, jj, jk     ! dummy loop indices
+      INTEGER  ::   irgb, ierror   ! temporary integer
+      REAL(wp) ::   zc0  , zc1  , zem     ! temporary scalars
+      REAL(wp) ::   zc2  , zc3  , zchl    !    -         -
+      REAL(wp) ::   zsi0r, zsi1r, zcoef   !    -         -
+      REAL(wp), DIMENSION(jpi,jpj)     ::   zekb, zekg, zekr              ! 2D workspace
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ze0 , ze1 , ze2 , ze3 , zea   ! 3D workspace
+      !!
+      CHARACTER(len=100) ::   cn_dir   ! Root directory for location of ssr files
+      TYPE(FLD_N)        ::   sn_chl   ! informations about the chlorofyl field to be read
+      NAMELIST/namqsr/  sn_chl, cn_dir, ln_traqsr, ln_qsr_rgb, ln_qsr_bio,   &
+         &              nn_chldta, rn_abs, rn_si0, rn_si1, rn_si2
+      !!----------------------------------------------------------------------
+
+      cn_dir = './'       ! directory in which the model is executed
+      ! ... default values (NB: frequency positive => hours, negative => months)
+      !            !     file       ! frequency !  variable  ! time interp !  clim   ! 'yearly' or ! weights  ! rotation   !
+      !            !     name       !  (hours)  !    name    !    (T/F)    !  (T/F)  ! 'monthly'   ! filename ! pairs      !
+      sn_chl = FLD_N( 'chlorophyll' ,    -1     ,  'CHLA'    ,  .true.     , .true.  ,   'yearly'  , ''       , ''         )
+      !
+      REWIND( numnam )            ! Read Namelist namqsr : ratio and length of penetration
+      READ  ( numnam, namqsr )
+      !
+      IF(lwp) THEN                ! control print
+         WRITE(numout,*)
+         WRITE(numout,*) 'tra_qsr_init : penetration of the surface solar radiation'
+         WRITE(numout,*) '~~~~~~~~~~~~'
+         WRITE(numout,*) '    Namelist namqsr : set the parameter of penetration'
+         WRITE(numout,*) '        Light penetration (T) or not (F)         ln_traqsr  = ', ln_traqsr
+         WRITE(numout,*) '        RGB (Red-Green-Blue) light penetration   ln_qsr_rgb = ', ln_qsr_rgb
+         WRITE(numout,*) '        bio-model            light penetration   ln_qsr_bio = ', ln_qsr_bio
+         WRITE(numout,*) '        RGB : Chl data (=1) or cst value (=0)    nn_chldta  = ', nn_chldta
+         WRITE(numout,*) '        RGB & 2 bands: fraction of light (rn_si1)    rn_abs = ', rn_abs
+         WRITE(numout,*) '        RGB & 2 bands: shortess depth of extinction  rn_si0 = ', rn_si0
+         WRITE(numout,*) '        2 bands: longest depth of extinction         rn_si1 = ', rn_si1
+         WRITE(numout,*) '        3 bands: longest depth of extinction         rn_si2 = ', rn_si2
+      ENDIF
+      !                         ! control consistency
+      IF( lk_qsr_bio .AND. .NOT.ln_qsr_bio ) THEN
+         ln_qsr_bio = .true.
+         CALL ctl_warn( 'Force bio-model light penetraton ln_qsr_bio  = TRUE ' )
+      ENDIF
+      
+      !                          ! ===================================== !
+      IF( ln_traqsr  ) THEN      !  Initialisation of Light Penetration  !  
+         !                       ! ===================================== !
+         !
+         zsi0r = 1.e0 / rn_si0
+         zsi1r = 1.e0 / rn_si1
+         !                                ! ---------------------------------- !
+         IF( ln_qsr_rgb ) THEN            !  Red-Green-Blue light penetration  !
+            !                             ! ---------------------------------- !
+            !
+            !                                ! level of light extinction
+            nksr = trc_oce_ext_lev( rn_si2, 0.33e2 )
+            IF(lwp) THEN
+               WRITE(numout,*)
+               WRITE(numout,*) '        level max of computation of qsr = ', nksr, ' ref depth = ', gdepw_0(nksr+1), ' m'
             ENDIF
+            !
+            CALL trc_oce_rgb( rkrgb )           !* tabulated attenuation coef.
+!!gm            CALL trc_oce_rgb_read( rkrgb )           !* tabulated attenuation coef.
+            !
+            IF( nn_chldta == 1 ) THEN           !* Chl data : set sf_chl structure
+               IF(lwp) WRITE(numout,*)
+               IF(lwp) WRITE(numout,*) '        Chlorophyll read in a file'
+               ALLOCATE( sf_chl(1), STAT=ierror )
+               IF( ierror > 0 ) THEN
+                  CALL ctl_stop( 'tra_qsr_init: unable to allocate sf_chl structure' )   ;   RETURN
+               ENDIF
+               ALLOCATE( sf_chl(1)%fnow(jpi,jpj)   )
+               ALLOCATE( sf_chl(1)%fdta(jpi,jpj,2) )
+               !                                        ! fill sf_chl with sn_chl and control print
+               CALL fld_fill( sf_chl, (/ sn_chl /), cn_dir, 'tra_qsr_init',   &
+                  &                                         'Solar penetration function of read chlorophyll', 'namqsr' )
+               !
+            ELSE                                !* constant Chl : compute once for all the distribution of light (etot3)
+               IF(lwp) WRITE(numout,*)
+               IF(lwp) WRITE(numout,*) '        Constant Chlorophyll concentration = 0.05'
+               IF(lwp) WRITE(numout,*) '        light distribution computed once for all'
+               !
+               zchl = 0.05                                 ! constant chlorophyll
+               irgb = NINT( 41 + 20.*LOG10(zchl) + 1.e-15 )
+               zekb(:,:) = rkrgb(1,irgb)                   ! Separation in R-G-B depending of the chlorophyl concentration
+               zekg(:,:) = rkrgb(2,irgb)
+               zekr(:,:) = rkrgb(3,irgb)
+               !
+               zcoef = ( 1. - rn_abs ) / 3.e0              ! equi-partition in R-G-B
+               ze0(:,:,1) = rn_abs
+               ze1(:,:,1) = zcoef
+               ze2(:,:,1) = zcoef 
+               ze3(:,:,1) = zcoef
+               zea(:,:,1) = tmask(:,:,1)                   ! = ( ze0+ze1+z2+ze3 ) * tmask
+               
+               DO jk = 2, nksr+1
+!CDIR NOVERRCHK
+                  DO jj = 1, jpj
+!CDIR NOVERRCHK   
+                     DO ji = 1, jpi
+                        zc0 = ze0(ji,jj,jk-1) * EXP( - fse3t(ji,jj,jk-1) * zsi0r     )
+                        zc1 = ze1(ji,jj,jk-1) * EXP( - fse3t(ji,jj,jk-1) * zekb(ji,jj) )
+                        zc2 = ze2(ji,jj,jk-1) * EXP( - fse3t(ji,jj,jk-1) * zekg(ji,jj) )
+                        zc3 = ze3(ji,jj,jk-1) * EXP( - fse3t(ji,jj,jk-1) * zekr(ji,jj) )
+                        ze0(ji,jj,jk) = zc0                 
+                        ze1(ji,jj,jk) = zc1
+                        ze2(ji,jj,jk) = zc2     
+                        ze3(ji,jj,jk) = zc3
+                        zea(ji,jj,jk) = ( zc0 + zc1 + zc2 + zc3 ) * tmask(ji,jj,jk)
+                     END DO
+                  END DO
+               END DO 
+               !
+               DO jk = 1, nksr
+                  etot3(:,:,jk) = ro0cpr * ( zea(:,:,jk) - zea(:,:,jk+1) ) / fse3t(:,:,jk)
+               END DO
+               etot3(:,:,nksr+1:jpk) = 0.e0                ! below 400m set to zero
+            ENDIF
+            !
+            !                             ! ---------------------------------- !
+         ELSE                             !    2 bands    light penetration    !
+            !                             ! ---------------------------------- !
+            !
+            !                                ! level of light extinction
+            nksr = trc_oce_ext_lev( rn_si1, 1.e2 )
+            IF(lwp) THEN
+               WRITE(numout,*)
+               WRITE(numout,*) '        level max of computation of qsr = ', nksr, ' ref depth = ', gdepw_0(nksr+1), ' m'
+            ENDIF
+            !
+            DO jk = 1, nksr                    !*  solar heat absorbed at T-point computed once for all
+               DO jj = 1, jpj                              ! top 400 meters
+                  DO ji = 1, jpi
+                     zc0 = rn_abs * EXP( -fsdepw(ji,jj,jk  )*zsi0r ) + (1.-rn_abs) * EXP( -fsdepw(ji,jj,jk  )*zsi1r )
+                     zc1 = rn_abs * EXP( -fsdepw(ji,jj,jk+1)*zsi0r ) + (1.-rn_abs) * EXP( -fsdepw(ji,jj,jk+1)*zsi1r )
+                     etot3(ji,jj,jk) = ro0cpr * (  zc0 * tmask(ji,jj,jk) - zc1 * tmask(ji,jj,jk+1)  ) / fse3t(ji,jj,jk)
+                  END DO
+               END DO
+            END DO 
+            etot3(:,:,nksr+1:jpk) = 0.e0                   ! below 400m set to zero
+            !
          ENDIF
-      ELSE
+         !                       ! ===================================== !
+      ELSE                       !        No light penetration           !                   
+         !                       ! ===================================== !
          IF(lwp) THEN
             WRITE(numout,*)
@@ -219,62 +380,4 @@
          ENDIF
       ENDIF
-
-      IF( rabs > 1.e0 .OR. rabs < 0.e0 .OR. xsi1 < 0.e0 .OR. xsi2 < 0.e0 ) &
-         CALL ctl_stop( '             0<rabs<1, 0<xsi1, or 0<xsi2 not satisfied' )
-
-      !                           ! Initialization of gdsr
-      IF( ln_zco .OR. ln_zps ) THEN
-         !
-         ! z-coordinate with or without partial step : same w-level everywhere inside the ocean
-         gdsr(:) = 0.e0
-         DO jk = 1, jpk
-            zdp1 = -gdepw_0(jk)
-            gdsr(jk) = ro0cpr * (  rabs  * EXP( zdp1/xsi1 ) + (1.-rabs) * EXP( zdp1/xsi2 )  )
-            IF ( gdsr(jk) <= 1.e-10 ) EXIT
-         END DO
-         indic = 0
-         DO jk = 1, jpk
-            IF( gdsr(jk) <= 1.e-15 .AND. indic == 0 ) THEN
-               gdsr(jk) = 0.e0
-               nksr = jk
-               indic = 1
-            ENDIF
-         END DO
-         nksr = MIN( nksr, jpkm1 )
-         IF(lwp) THEN
-            WRITE(numout,*)
-            WRITE(numout,*) '        - z-coordinate, level max of computation =', nksr
-            WRITE(numout,*) '             profile of coef. of penetration:'
-            WRITE(numout,"('              ',7e11.2)") ( gdsr(jk), jk = 1, nksr )
-            WRITE(numout,*)
-         ENDIF
-         ! Initialisation of Biological fluxes for light here because
-         ! the optical biological model is call after the dynamical one
-         IF( lk_qsr_sms .AND. ln_qsr_sms ) THEN
-            DO jk = 1, jpkm1
-               zcst = gdsr(jk) / ro0cpr
-               etot3(:,:,jk) = qsr(:,:) * zcst * tmask(:,:,jk) 
-            END DO
-         ENDIF
-         !
-      ENDIF
-
-      ! Initialisation of etot3 (s-coordinate)
-      ! -----------------------
-      IF( ln_sco ) THEN
-         etot3(:,:,jpk) = 0.e0
-         DO jk = 1, jpkm1
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  zdp1 = -fsdepw(ji,jj,jk  )
-                  zdp2 = -fsdepw(ji,jj,jk+1)
-                  zc0  = ro0cpr / fse3t(ji,jj,jk)
-                  zc1  =   (  rabs * EXP(zdp1/xsi1) + (1.-rabs) * EXP(zdp1/xsi2)  )
-                  zc2  = - (  rabs * EXP(zdp2/xsi1) + (1.-rabs) * EXP(zdp2/xsi2)  )
-                  etot3(ji,jj,jk)  = zc0 * (  zc1 * tmask(ji,jj,jk) + zc2 * tmask(ji,jj,jk+1)  )
-               END DO
-            END DO
-         END DO 
-      ENDIF
       !
    END SUBROUTINE tra_qsr_init